//uses algorithms adapted from DiffCAD

public class DFT{

	public static Complex[] computeTransform(Complex[] input){
        int N = input.length;
        double twoPiOnN = 2 * Math.PI / N;
        double twoPikOnN;
        double twoPitkOnN;

		Complex[] output = new Complex[N];

        for (int k = 0; k < N; k++) {
            twoPikOnN = twoPiOnN * k;
			output[k] = new Complex(0,0);
	        for (int t = 0; t < N; t++) {
                twoPitkOnN = twoPikOnN * t;
                output[k] = Complex.add(
                	output[k],
	                Complex.multiply(
	                	input[t],
	                	new Complex(
	                		(float)Math.cos(twoPitkOnN),
	                		(float)-Math.sin(twoPitkOnN)
	                	)
	                )
	            );
            }
        }
        return output;	
	}
	
	public static Complex[] computeInverse(Complex[] input){
        int N = input.length;
        double twoPiOnN = 2 * Math.PI / N;
        double twoPitOnN;
        double twoPitkOnN;

        Complex[] output = new Complex[N];

        for (int t = 0; t < N; t++) {
            twoPitOnN = twoPiOnN * t;
            output[t] = new Complex(0,0);
            for (int k = 0; k < N; k++) {
                twoPitkOnN = twoPitOnN * k;
				output[t] = Complex.add(
					output[t],
					Complex.multiply(
						input[k],
						new Complex(
							(float)Math.cos(twoPitkOnN)/N,
							(float)Math.sin(twoPitkOnN)/N
						)
					)
				); 
            }
        }
        return output;
    }
}