package audio;

// SW 511 JCapture Demo;  JCaptures and plays back audio.
// Doug Lyon refactor Sept 30, 2002

import java.awt.*;
import javax.swing.*;
import gui.RunButton;
import futils.*;

// to run the program use:
// audio.JCapture as the main class.

public class JCapture extends JFrame implements AudioPlayerListener{
    AudioPlayer al = new AudioPlayer();
    JTextField audioFormatField = new JTextField();
    JPanel buttonBar = new JPanel();
    JTextField stateField = new JTextField(10);

    // Constructor:
    public JCapture() {
		super("Audio Capture Tool");
		
		al.addAudioPlayerListener(this);

        buttonBar.setLayout(new FlowLayout());

        buttonBar.add(new RunButton("Capture") {
            public void run() {
            	try{
	                al.captureAudio();
	                updateUIStrings();
	            }catch (AudioPlayerException a){
	            	messageBox(a.getMessage());
	            }
            }
        });
        buttonBar.add(new RunButton("Stop") {
            public void run() {
                al.stop();
            }
        });
        buttonBar.add(new RunButton("Play") {
            public void run() {
            	try{
                	al.playAudio();
	            }catch (AudioPlayerException a){
	            	messageBox(a.getMessage());
	            }
            }
        });
        buttonBar.add(new RunButton("Save") {
            public void run() {
            	try{
	                al.saveAudioFile(Futil.getWriteFileName());
	                updateUIStrings();
	            }catch (AudioPlayerException a){
	            	messageBox(a.getMessage());
	            }
            }
        });
        buttonBar.add(new RunButton("Open") {
            public void run() {
            	try{
	                al.openAudioFile(Futil.getReadFileName());
	                updateUIStrings();
	            }catch (AudioPlayerException a){
	            	messageBox(a.getMessage());
	            }
            }
        });
		buttonBar.add(stateField);
		stateField.setEditable(false);

		audioFormatField.setEditable(false);

        Container contentPane = getContentPane();
		
		contentPane.setLayout(new BorderLayout());
		contentPane.add(buttonBar, BorderLayout.NORTH);
		contentPane.add(audioFormatField, BorderLayout.SOUTH);
         
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE); 

    } // End Constructor

	public void audioStateChanged(AudioPlayer.State s){
		stateField.setText(s.toString());
	}

	private void messageBox(String s){
		JOptionPane.showMessageDialog(this, s, "Audio Capture Tool", JOptionPane.WARNING_MESSAGE);
	}

	private void updateUIStrings(){
        setTitle("Audio Capture Tool - " + al.getAudioDescription());
        audioFormatField.setText(al.getFormat().toString());
	}

    public static void main(String args[]) {
        JCapture c = new JCapture();
        c.setSize(500, 200);
        c.show();
    }
}
