package RajusTTS;
// Uses functionality built by Glenn's audio package
// extended to add TextToSpeech interface

import audio.*;
import java.io.*;
import javax.sound.sampled.*;
import javax.swing.event.*;
//import audio.AudioPlayerException;

public class AudioPlayerR extends AudioPlayer{
	
	public AudioPlayerR() {
		super();
	}
	
	public void makeTTSAudio(int typ, String allophoneString) throws AudioPlayerException{
       	int bufferSize;
	    byte buffer[];
	    TargetDataLine line = null;
	    String errorString = null;

		// As this class only maintains one array of recorded data,
		// multiple instances of capture cannot be occuring simultaneously.
		// Play and record share both share this same array, so it is also
		// not possible to play and record at the same time.
		if (isCapturing){
			throw new AudioPlayerException(" Multiple simultaneous captures not allowed.");
		}
		if (isPlaying){
			throw new AudioPlayerException(" Simultaneous play and record not allowed.");
		}		
		
	    format = defaultFormat;
	    
	    ByteArrayOutputStream recordedByteStream = new ByteArrayOutputStream();
		fireStateChangedEvent(State.RECORDING);
	    isCapturing = true;

		if (typ==0)
		{
			Talker talker = new Talker();
			talker.sayPhoneWord(allophoneString);
		
			recordedByteStream = talker.getRecordedByteStream();
			if (recordedByteStream != null)
			{
				audioByteArray = recordedByteStream.toByteArray();
			}
		
			isCapturing = false;
			fireStateChangedEvent(State.IDLE);
		}
		else
		{
			Bleeter talker = new Bleeter();
			talker.sayPhoneWord(allophoneString);
		
			recordedByteStream = talker.getRecordedByteStream();
			if (recordedByteStream != null)
			{
				audioByteArray = recordedByteStream.toByteArray();
			}
		
			isCapturing = false;
			fireStateChangedEvent(State.IDLE);
		}
	}
	public void makeTTSAudio2(int typ, String allophoneString) throws AudioPlayerException{
       	int bufferSize;
	    byte buffer[];
	    TargetDataLine line = null;
	    String errorString = null;

		// As this class only maintains one array of recorded data,
		// multiple instances of capture cannot be occuring simultaneously.
		// Play and record share both share this same array, so it is also
		// not possible to play and record at the same time.
		if (isCapturing){
			throw new AudioPlayerException(" Multiple simultaneous captures not allowed.");
		}
		if (isPlaying){
			throw new AudioPlayerException(" Simultaneous play and record not allowed.");
		}		
		
	    format = defaultFormat;
	    
	    ByteArrayOutputStream recordedByteStream = new ByteArrayOutputStream();
		fireStateChangedEvent(State.RECORDING);
	    isCapturing = true;

		if (typ==0)
		{
			Talker talker = new Talker();
			talker.sayPhoneWord(allophoneString);
		
			recordedByteStream = talker.getRecordedByteStream();
			if (recordedByteStream != null)
			{
				audioByteArray = recordedByteStream.toByteArray();
			}
		
			isCapturing = false;
			fireStateChangedEvent(State.IDLE);
		}
		else
		{
			Bleeter talker = new Bleeter();
			talker.sayPhoneWord2(allophoneString);
		
			recordedByteStream = talker.getRecordedByteStream();
			if (recordedByteStream != null)
			{
				audioByteArray = recordedByteStream.toByteArray();
			}
		
			isCapturing = false;
			fireStateChangedEvent(State.IDLE);
		}
	}

}

